Subject: "Clear all caches" makes the site unavailable for several seconds
Description

Clear all caches makes the site unavailable for several seconds. This is caused by the fact that the complete classloader cache is
killed and rebuilt on this action.

And even more worse: If other requests are coming in during this "warm-up" progress, they fail with an exception in some cases
because the autoloader doesn't find a required file.

to reproduce this open the Backend and the frontend in one Browser and one or more Frontends in other browsers, hit clear all
caches in the backend and then hit F5 in the other browser windows. I mostly need only one or two tries to end up with a white page
and an exception in the error log. (btw: my classloader cache is configured to use the memcached backend, so it can't be caused by a
slow harddisk)

"clear all caches" happens quite often during clicking around in the backend. 
for instance on:
- saving TS templates in Template module
- installing/de-installing extensions
- copying/moving pages recursively 
- and some more ....

possible solution:
1. exclude the classloader cache from clear all caches
2. implement a more stable classloader cache rebuilding mechanism

Related issues:
related to Core - Story # 54991: Improve caching framework by introducing groups Resolved 2014-01-15
related to Core - Bug # 55029: Class Loader fails if entry in class cache is ... Closed 2014-01-15

History
#1 - 2014-01-14 16:36 - Markus Klein
- Parent task set to #52949

#2 - 2014-01-16 16:40 - Ingo Schmitt
- Parent task changed from #52949 to #55073

#3 - 2014-01-20 16:33 - Ingo Schmitt
- Category set to Performance
#4 - 2014-02-04 10:15 - Rupert Germann

this issue is partly solved or at least mitigated by the introduction of "Caching Groups" (#54991)
now only the "Clear all Cache" button in the installtool and installing/removing extensions actually clears all caches including the
packamanager/classloader caches.
if this has to happen, the site will still be unavaiable for several seconds:
I measured: 
   ~ 4 seconds (cache_classes in APC), 
   ~ 13 seconds (cache_classes in Files on a normal Harddisk) and 
   ~ 40 seconds (cache_classes in Files on NFS)

in case another request hits the site during the cache rebuilding process, there's a good chance that this request causes a permanent fatal error. This
leaves the caches in an inconsistent state which requires that someone logs in via SSH and removes typo3temp/Cache by hand.

Helmut had an idea how to tackle this problem in http://forge.typo3.org/issues/55029

#5 - 2015-01-24 09:41 - Mathias Schreiber
- Status changed from New to Closed

composer classloader fixes this

#6 - 2015-04-21 17:19 - Lars Houmark

This one should be re-opened.

I know it is fixed in 7.1 but since 6.2 is the only supported LTS at this time, and since it is LTS either the classloader or another bugfix should be done
to 6.2 LTS as sites running NFS in production is breaking constantly for us when deploying new things that requires a cache clearing (a simple
locallang update in an extension requires deep cache cleaning).

Anyone has a workaround for this? I'm honestly still confused to when and how this happens and how we can work around it (we recently started using
a hosting platform based on NFS filesystem).

#7 - 2015-06-11 14:20 - José Ricardo

Agree with reopening. Clearing all caches in TYPO3 6.2 crashes the whole site for a few minutes.

#8 - 2015-06-19 15:54 - Oliver Krammer

Also agree with reopening! We have a big site with 6.2 wich is running on NFS. And we have the same problem.

#9 - 2015-07-10 16:44 - DKLIK INTERACTIV

I also agree with re-opening this issue : we have several websites running with typo3 6.2, some of them are multilingual. Every time we made a change
in a locallang file (for example), we need to click on the "clear system cache" in the backend, but this action makes the site unavailable until we
remove the typo3temp folder via SSH (no other solution has been found at the moment).
#10 - 2015-07-20 12:03 - Alexander Wende

Agree with reopening! We have a big 6.2 site. Since 6.2 this problem occurs very often (nearly every day). If there isn't any solution, I'll have to migrate
to 7.1. IMHO 6.2 is (atm) not usable for production purpose. 
I'm not a developer hero but when I could help, I would try.
